package cn.sagacloud.server.scheduler.controllers

import cn.sagacloud.server.scheduler.models.DownloadEntity
import cn.sagacloud.server.scheduler.models.DownloadSpeedRequest
import cn.sagacloud.server.scheduler.models.TaskEntity
import cn.sagacloud.server.scheduler.service.BaseDataService
import cn.sagacloud.server.scheduler.service.JMSProducer
import com.alibaba.fastjson.JSON
import com.sybotan.base.extensions.toJson
import com.sybotan.mybatis.SMybatisDao
import com.sybotan.service.SObjectService
import com.sybotan.service.models.requests.SCreateRequest
import com.sybotan.service.models.requests.SQueryRequest
import com.sybotan.service.models.requests.SUpdateRequest
import com.sybotan.service.models.responses.*
import io.swagger.annotations.Api
import io.swagger.annotations.ApiOperation
import org.slf4j.LoggerFactory
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController
import java.util.*
import kotlin.collections.ArrayList

@Api(tags = ["download接口"])
@RestController
@RequestMapping("/download")
open class DownloadController {
    companion object {
        // 日志
        private val logger = LoggerFactory.getLogger(DownloadController::class.java)
    } // Companion object

   /* @Autowired
    lateinit var activeMQ : JMSProducer*/
    /**
     * 下载速度
     */
/*
    @ApiOperation(value = "下载速度", notes = "")
    @PostMapping(value = ["/speed"])
    fun speed(@RequestBody request: DownloadSpeedRequest): SBaseResponse {
        logger.debug("task =${request.toJson()}")
        // 如果已下载完, 则给完成时间加上
        if(request.totalBytes != null && request.totalBytes!! > -1L && request.taskId != null) {
            if (request.downloadedBytes == request.totalBytes) {
                val task = TaskEntity()
                task.id = request.taskId
                task.downloadFinishTime = Date()
                BaseDataService.taskService.update(task, arrayListOf("downloadFinishTime"))
            }
        }
        // 发送到MQ
        try {
            activeMQ.sendMessage(JSON.toJSONString(request))
        }catch (ignore : Exception){}
        return SBaseResponse()
    } // Function create()
*/

//    /**
//     * 创建Task
//     */
//    @ApiOperation(value = "创建Task", notes = "")
//    @PostMapping(value = ["/create"])
//    fun create(@RequestBody taskEntity: ArrayList<DownloadEntity>): SCreateResponse<DownloadEntity> {
//        logger.debug("equip =${taskEntity.toJson()}")
//        val request = SCreateRequest<DownloadEntity>()
//        request.content = taskEntity
//        return downloadService.createList(request)
//    } // Function create()
    /**
     * 创建Task
     */
    @ApiOperation(value = "创建Task", notes = "")
    @PostMapping(value = ["/create"])
    fun create(@RequestBody request: SCreateRequest<DownloadEntity>): SCreateResponse<DownloadEntity> {
        logger.debug("task =${request.toJson()}")
        return BaseDataService.downloadService.createList(request)
    } // Function create()
    /**
     * 更新Task
     *
     * @param   request     更新请求
     * @return  更新结果应答信息
     */
    @ApiOperation(value="更新Task", notes="")
    @PostMapping(value = ["/update"])
    fun update(@RequestBody request: SUpdateRequest<DownloadEntity>): SBaseResponse {
        return BaseDataService.downloadService.updateList(request)
    } // Function update()

    /**
     * 查询Task
     *
     * @param   request     查询请求
     * @return  查询结果应答信息
     */
    @ApiOperation(value="查询Task", notes="")
    @PostMapping(value = ["/query"])
    fun query(@RequestBody request: SQueryRequest): SQueryResponse<DownloadEntity> {
        return BaseDataService.downloadService.pageQuery(request)
    } // Function query()


    /**
     * 删除下载Task
     *
     * @param   idList      TaskEntity ID列表
     * @return  删除结果应答信息
     */
    @ApiOperation(value = "删除Task", notes = "")
    @PostMapping(value = ["/delete"])
    fun delete(@RequestBody idList: ArrayList<DownloadEntity>): SBaseResponse {
        return BaseDataService.downloadService.deleteByKeysList(idList)
    } // Function delete()
}